<!DOCTYPE html>
<html lang="en">

<head>
  <title>Bootstrap Example</title>
  <meta charset="utf-8">
  <meta name="viewport" content="width=device-width, initial-scale=1">
  <link rel="stylesheet" href="https://maxcdn.bootstrapcdn.com/bootstrap/4.5.2/css/bootstrap.min.css">
  <script src="https://ajax.googleapis.com/ajax/libs/jquery/3.5.1/jquery.min.js"></script>
  <script src="https://maxcdn.bootstrapcdn.com/bootstrap/4.5.2/js/bootstrap.min.js"></script>
</head>

<body>

  <div class="container">
    <div class="text-center my-4">
      <h2>Danh sách người dùng</h2>
    </div>

    <table id="table-user" class="table table-bordered table-striped table-hover">
      <thead>
        <tr>
          <th>Mã người dùng</th>
          <th>Firstname</th>
          <th>Lastname</th>
          <th>Age</th>
          <th>Action</th>
        </tr>
      </thead>
      <tbody>
      
      </tbody>
    </table>
  </div>
  
  <script>
    "use strict";
    /*** REGION 1 - Global variables - Vùng khai báo biến, hằng số, tham số TOÀN CỤC */
    var gJsonUser = `{
    "description": "Data user",
    "users": [
      {
        "userId": 1,
        "firstname": "Test1",
        "lastname": "User1",
        "age": 18
      },
      {
        "userId": 2,
        "firstname": "Test2",
        "lastname": "User2",
        "age": 19
      },
      {
        "userId": 3,
        "firstname": "Test3",
        "lastname": "User3",
        "age": 18
      },
      {
        "userId": 4,
        "firstname": "Test4",
        "lastname": "User4",
        "age": 20
      },
      {
        "userId": 5,
        "firstname": "Test5",
        "lastname": "User5",
        "age": 21
      },
      {
        "userId": 6,
        "firstname": "Test6",
        "lastname": "User6",
        "age": 20
      }
    ]
  }`;
    
    var gUserOjb = JSON.parse(gJsonUser);

    /*** REGION 2 - Vùng gán / thực thi sự kiện cho các elements */
    $(document).ready(function(){
      onPageLoading();

      $(".user-detail").click(function(){
        onBtnDetailButtonClick(this);
      })
    })


    /*** REGION 3 - Event handlers - Vùng khai báo các hàm xử lý sự kiện */
    function onPageLoading(){

      loadDataToUserTable(gUserOjb.users)
   
    }

    function onBtnDetailButtonClick(paramButton){
        console.log("clicked")
        var vUserId = $(paramButton).data("userid");
        var vUserFirstname = $(paramButton).data("firstname");
        var vUserLastname = $(paramButton).data("lastname");
        var vUserAge = $(paramButton).data("age");
        console.log("User-Id: ", vUserId);
        console.log("Firstname: ", vUserFirstname);
        console.log("Lastname: ", vUserLastname);
        console.log("Age: ", vUserAge);
    }

    /*** REGION 4 - Common funtions - Vùng khai báo hàm dùng chung trong toàn bộ chương trình*/
    
    function loadDataToUserTable(paramUser){
      var vUserTable = $('#table-user');
        for (var i=0; i < paramUser.length; i++){;
      /*  //Option 1    
          var bNewRow = $('<tr></tr>').appendTo(vUserTable);
          var bUserIdCell = $('<td>').appendTo(bNewRow);
          bUserIdCell.html(paramUser[i].userId)  

        //Option 2
          $('<td>').html(paramUser[i].userId).appendTo(bNewRow);
      */
        // Option 3
        var bNewRow = $('<tr></tr>').appendTo(vUserTable);
        $('<td>', {html: paramUser[i].userId}).appendTo(bNewRow);
        $('<td>', {html: paramUser[i].firstname}).appendTo(bNewRow);
        $('<td>', {html: paramUser[i].lastname}).appendTo(bNewRow);
        $('<td>', {html: paramUser[i].age}).appendTo(bNewRow);
                
        var bActionCell = $('<td>').appendTo(bNewRow);
    /*  // Option 1:  var bDetailButton = $("<button>").html("Chi tiết").appendTo(bActionCell);
          
        // Option 2:  
          $("<button>", {
                html: "Chi Tiết",
                class: "btn, btn-info"
            }).click(function(){
                onBtnDetailButtonClick(this);
            })
            .appendTo(bActionCell);
    */    
        // Option 3:  
        $("<button>", {
              html: "Chi Tiết",
              class: "btn, btn-info user-detail"
          }).data("userid", paramUser[i].userId)
          .data("firstname", paramUser[i].firstname)
          .data("lastname", paramUser[i].lastname)
          .data("age", paramUser[i].age)
          .appendTo(bActionCell);
        }  
      } 
</script>
</body>

</html>
​